<template>
  <article class="view view--content-page-view">
    <LoadingSpinner v-if="loading" />
    <span v-if="loaded" v-html="page.content" />
  </article>
</template>

<script>
import { ref, computed, onMounted, onUpdated, onUnmounted, watch } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { UrlHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import PagesApi from '../../api/pages-api.js'

export default {
  name: 'ContentPageViewView',
  components: {
    LoadingSpinner,
  },
  setup() {
    const route = useRoute()
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const pagesApi = new PagesApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const page = ref(undefined)
    const eventListeners = ref([])

    const id = computed(() => {
      return route.meta.id
    })

    const loadAsync = async () => {
      if (id.value === null) {
        return
      }

      loading.value = true
      loaded.value = false
      page.value = null

      try {
        const response = await pagesApi.readAsync(id.value)
        page.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the page content.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    onUpdated(() => {
      document.querySelectorAll('.page--content a').forEach((element) => {
        // We don't need to explicitly remove this later, because the elements will be destroyed anyway.
        element.addEventListener('click', (event) => {
          event.preventDefault()
          const href = event.target.pathname

          // true: fallback to standard navigation if no route is found.
          UrlHelper.routeTo(router, href, true)
        })
      })
    })

    onUnmounted(() => {
      eventListeners.value.forEach((listener) => listener)
    })

    watch(route, async () => {
      await loadAsync()
    })

    return {
      page,
      loading,
      loaded,
      id,
    }
  },
}
</script>
